<template>
  <div @click="dialog = !dialog">
    <!-- ダイアローグが表示されている場合 -->
    <v-dialog v-model="dialog">
      <v-card>
        <v-card-title class="headline">
          <span>入力 (島名)</span>
        </v-card-title>
        <v-card-text>
          <!-- カブ価 -->
          <v-text-field
            label="島名"
            v-model="inputName"
            type="text"
            autofocus
            @keydown.enter="save"
          />
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel">CANCEL</v-btn>
          <v-btn color="green" @click="save">SAVE</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- ダイアローグが表示されていない場合 -->
    <div v-show="!dialog">
      <span>{{ name }}</span>
      <v-icon class="ml-2 grey--text">mdi-pencil</v-icon>
    </div>
  </div>
</template>

<script>
export default {
  data () {
    return {
      // ダイアローグが表示されているかどうか
      dialog: false,
      // 入力された島名
      // 初期値はStoreの島名
      inputName: this.name
    }
  },
  methods: {
    /**
     * ダイアローグを閉じる
     */
    closeDialog () {
      this.dialog = false
    },

    /**
     * SAVEボタン処理
     */
    save () {
      // 島名を設定する
      const arg = { name: this.inputName }
      this.$store.dispatch('stock/setName', arg)
      // ダイアローグを閉じる
      this.closeDialog()
    },

    /**
     * CANCELボタン処理
     */
    cancel () {
      // ダイアローグを閉じる
      this.closeDialog()
    }
  },
  computed: {
    // Storeの島名
    name () {
      return this.$store.getters['stock/name']
    }
  }
}
</script>

<style scoped>
</style>
